/*
	SQLSTUDIOServices.m
	Creates a list of the services available with the SQLSTUDIO prefix.
	Generated by SudzC.com
*/
#import "SQLSTUDIOServices.h"

@implementation SQLSTUDIOServices

@synthesize logging, server, defaultServer;

@synthesize myService;


#pragma mark Initialization

-(id)initWithServer:(NSString*)serverName{
	if(self = [self init]) {
		self.server = serverName;
	}
	return self;
}

+(SQLSTUDIOServices*)service{
	return (SQLSTUDIOServices*)[[[SQLSTUDIOServices alloc] init] autorelease];
}

+(SQLSTUDIOServices*)serviceWithServer:(NSString*)serverName{
	return (SQLSTUDIOServices*)[[[SQLSTUDIOServices alloc] initWithServer:serverName] autorelease];
}

#pragma mark Methods

-(void)setLogging:(BOOL)value{
	logging = value;
	[self updateServices];
}

-(void)setServer:(NSString*)value{
	[server release];
	server = [value retain];
	[self updateServices];
}

-(void)updateServices{

	[self updateService: self.myService];
}

-(void)updateService:(SoapService*)service{
	service.logging = self.logging;
	if(self.server == nil || self.server.length < 1) { return; }
	service.serviceUrl = [service.serviceUrl stringByReplacingOccurrencesOfString:defaultServer withString:self.server];
}

#pragma mark Getter Overrides


-(SQLSTUDIOMyService*)myService{
	if(myService == nil) {
		myService = [[SQLSTUDIOMyService alloc] init];
	}
	return myService;
}


@end
			